#ifndef _PBVLAN_H_
#define _PBVLAN_H_

#include <linux/netdevice.h>
struct net_device_stats *vlan_dev_get_stats(struct net_device *dev);
int vlan_dev_hard_start_xmit(struct sk_buff *skb, struct net_device *dev);
int vlan_dev_change_mtu(struct net_device *dev, int new_mtu);
int vlan_dev_open(struct net_device *dev);
int vlan_dev_stop(struct net_device *dev);
int vlan_dev_init(struct net_device *dev);

struct pbvlan_dev_info {
	struct net_device *real_dev;
	unsigned short vlan_id;
	struct net_device_stats dev_stats;
};

#define PBVLAN_DEV_INFO(x) ((struct pbvlan_dev_info *)(x->priv))
#define MAX_PB_VLAN 4
#define IFF_PB_VLAN 1
#define ETH_IF_NAME "eth0"


// register all vlan device
void register_pb_vlan_device_all( void );
// unregister all vlan device
void unregister_pb_vlan_device_all(void);
void reset_ingress( void );

// get vlan dev for a lan port
struct net_device * pb_vlan_get_device( int lan_port_id);

// get DPV for a vlan
unsigned short pb_vlan_get_DPV( int vlan_id);

#endif // _PBVLAN_H_

